#!/bin/sh

PKG_STR_WIZARD_UPDATE_TITLE="Instalar o Synology Drive Server"
PKG_STR_WIZARD_UPDATE_DESC_CLOUD="O Synology Drive Server é o sucessor do Cloud Station."
PKG_STR_WIZARD_UPDATE_DESC_OFFICE="O Synology Drive Server é um portal de ficheiros universal que integra o Synology Office."
PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE="O Synology Drive Server é o sucessor do Cloud Station e serve como o portal para o Synology Office."

PKG_STR_WIZARD_INSTALL_ACTIVATE="var form=arguments[0];var isCloudStationMigrate=__IS_CLOUD_MIGRATE__,isShareSyncMigrate=__IS_SHARESYNC_MIGRATE__,isOfficeMigrate=__IS_OFFICE_MIGRATE__;if(1===form.items.items.length){var note=\\\"\\\";if(isCloudStationMigrate){note+=\\\"<li>\\\"+\\\"O <b>Cloud Station Server</b> será substituído: os dados e as definições no <b>Cloud Station Server</b> serão migrados para o <b>Synology Drive Server</b>\\\"+\\\"</li>\\\"}if(isShareSyncMigrate){note+=\\\"<li>\\\"+\\\"O <b>Cloud Station ShareSync</b> será substituído: os dados e as definições no <b>Cloud Station ShareSync</b> serão migrados com segurança para o <b>Synology Drive Server</b>\\\"+\\\"</li>\\\"}if(isOfficeMigrate){note+=\\\"<li>\\\"+\\\"O <b>Synology Office</b> será integrado: os dados no <b>Synology Office</b> serão migrados com segurança para o <b>Synology Drive Server</b> e podem ser abertos através do portal universal <b>Synology Drive</b>.\\\"+\\\"</li>\\\"}note+=\\\"<li>\\\"+\\\"Não é possível passar para a versão anterior\\\"+\\\"</li>\\\";form.add(new SYNO.ux.DisplayField({htmlEncode:false,value:\\\"Antes de instalar o Synology Drive Server, tenha em atenção o seguinte:\\\"+\\\"<br>\\\"+\\\"<ul style='padding-left:5px;list-style:disc inside;'>\\\"+note+\\\"</ul><br><span>\\\"+\\\"Visite <a target=\\\\"_blank\\\\" href=\\\\"https://www.synology.com/knowledgebase/DSM/tutorial/Collaboration/What_do_I_need_to_know_before_upgrading_from_Cloud_Station_to_Synology_Drive_2_0\\\\">esta página</a> para obter mais informações antes de atualizar para o Synology Drive Server.\\\"+\\\"</span>\\\"}));form.doLayout()}if(isCloudStationMigrate||isShareSyncMigrate){var container=arguments[1];var nextStepButton=container.owner.getFooterToolbar().getComponent('next');var backStepButton=container.owner.getFooterToolbar().getComponent('back');var clickEventListeners=[];nextStepButton.mons.forEach(function(item){if(item.ename==='click'){clickEventListeners.push(item)}});clickEventListeners.forEach(function(item){nextStepButton.mun(item.item,item.ename,item.fn,item.scope)});var onClickNextButton=function(e){var msgDescription=\\\"\\\";if(isCloudStationMigrate&&isShareSyncMigrate){msgDescription=\\\"O Cloud Station Server e o Cloud Station ShareSync serão substituídos pelo Synology Drive Server após a instalação e as suas definições serão migradas. Pretende continuar?\\\"}else if(isCloudStationMigrate){msgDescription=\\\"O Cloud Station Server será substituído pelo Synology Drive Server após a instalação e as suas definições serão migradas. Pretende continuar?\\\"}else if(isShareSyncMigrate){msgDescription=\\\"O Cloud Station ShareSync será substituído pelo Synology Drive Server após a instalação e as suas definições serão migradas. Pretende continuar?\\\"}form.owner.getMsgBox().confirm(\\\"\\\",msgDescription,function(button){if(button==='yes'){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton);nextStepButton.el.dom.click()}})};var onClickBackButton=function(e){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton)};nextStepButton.mon(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mon(backStepButton.el,'click',onClickBackButton,backStepButton)}"

OFFICE_PKG_PATH="/var/packages/Spreadsheet/"
OFFICE_INFO_FILE=${OFFICE_PKG_PATH}"INFO"
CLOUDSTATION_PKG_PATH="/var/packages/CloudStation/"
CLOUDSTATIONCLIENT_PKG_PATH="/var/packages/CloudStationClient/"
VER_KEY="version"
OLD_OFFICE_MAJOR_VERSION=2
OLD_OFFICE_MINOR_VERSION=2



IsOfficeMigrate()
{
	if [ ! -f "${OFFICE_INFO_FILE}" ]; then
		return 0
	fi

	local office_major=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 1)
	local office_minor=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 2)

	if [ ${office_major} -lt ${OLD_OFFICE_MAJOR_VERSION} ] || [ ${office_major} -eq ${OLD_OFFICE_MAJOR_VERSION} -a ${office_minor} -le ${OLD_OFFICE_MINOR_VERSION} ]; then
		return 1
	fi
	return 0
}

IsCloudStationMigrate()
{
	if [ -d ${CLOUDSTATION_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

IsCloudStationClientMigrate()
{
	if [ -d ${CLOUDSTATIONCLIENT_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

main()
{
	local InstallPages=""
	IsOfficeMigrate
	local office_migrate=$?
	IsCloudStationMigrate
	local cloud_migrate=$?
	IsCloudStationClientMigrate
	local sharesync_migrate=$?

	if [ "$office_migrate" = "0" ] && [ "$cloud_migrate" = "0" ] && [ "$sharesync_migrate" = "0" ]; then
		InstallPages=""
	else
		local title=${PKG_STR_WIZARD_UPDATE_TITLE}
		local description
		local activate=${PKG_STR_WIZARD_INSTALL_ACTIVATE}

		if [ "$office_migrate" = "0" ]; then
			description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD}
		else
			if [ "$cloud_migrate" = "1" ] || [ "$sharesync_migrate" = "1" ]; then
				description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE}
			else
				description=${PKG_STR_WIZARD_UPDATE_DESC_OFFICE}
			fi
		fi

		if [ "$office_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/false/g'`
		fi
		if [ "$cloud_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/false/g'`
		fi
		if [ "$sharesync_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/false/g'`
		fi
		
		InstallPages=`/bin/cat<<EOF
{
	"step_title": "${title}",
	"activeate": "{${activate}}",
	"items": [{
		"desc": "${description}"
	}]
}
EOF`
	fi

/bin/cat > ${SYNOPKG_TEMP_LOGFILE} <<EOF
[${InstallPages}]
EOF

	exit 0
}

main "$@"
