#!/bin/sh

PKG_STR_WIZARD_WZ_RM_TITLE="Rimuovere dati e impostazioni di Synology Drive Server"
PKG_STR_WIZARD_WZ_REMOVEDB_DESC="<style>ul.drive-wizard-list li { list-style-type: square; list-style-position: inside; }</style>Quando si disinstalla Synology Drive Server, è possibile scegliere se eliminare il database contenente i seguenti elementi. Dopo essere stato eliminato, il database non potrà esser ripristinato.<ul class="drive-wizard-list"><li>File Synology Office (se presenti)</li><li>Impostazioni di condivisione dei file</li><li>Asterischi ed etichette</li><li>Cronologia delle versioni e file del Cestino</li></ul>"
PKG_STR_WIZARD_WZ_REMOVEDB="Rimuovere il database Synology Drive Server"

PKG_STR_WIZARD_ACTIVATE_JS="Ext.define('SYNO.SDS.Drive.Wizard.ConfirmDialog',{extend:'SYNO.SDS.ModalWindow',constructor:function(cfg){SYNO.Assert(cfg.confirmText,'need confirmText');SYNO.Assert(cfg.checkboxText,'need checkboxText');var config={cls:'x-window-dlg',resizable:false,minimizable:false,maximizable:false,closable:false,stateful:false,dsmStyle:'v5',maxWidth:600,minWidth:300,header:false,draggable:false,buttonAlign:'right',elements:'body',padding:'20px 20px 0 20px',footer:true,fbar:new Ext.Toolbar({enableOverflow:false,items:[this.applyBtn=new SYNO.ux.Button({btnStyle:'red',text:cfg.closeText||_T('common','yes'),disabled:true,handler:this.onApply,scope:this}),{xtype:'syno_button',btnStyle:'grey',text:cfg.cancelText||_T('common','no'),handler:this.onCancel,scope:this}]}),items:[{xtype:'syno_displayfield',hideLabel:true,value:cfg.confirmText},{xtype:'syno_checkbox',name:'understand',cls:'close-confirm-warning',boxLabel:cfg.checkboxText,listeners:{scope:this,check:this._onUpdateUnderstand,afterrender:this._onAfterCheckboxRender}}]};this.callParent([Ext.apply(config,cfg)])},_onAfterCheckboxRender:function(checkbox){checkbox.el.parent().select('.syno-ux-checkbox-label').addClass('red-status')},_onUpdateUnderstand:function(checkbox,check){this.setEnableApplyBtn(check)},setEnableApplyBtn:function(enable){this.applyBtn[enable?'enable':'disable']()},onApply:function(){this.fireEvent('apply');this.close()},onCancel:function(){this.fireEvent('cancel');this.close()}});var displayConfirmMessage=function(checkbox,checked){if(!checked){return}var win=new SYNO.SDS.Drive.Wizard.ConfirmDialog({owner:checkbox.findWindow(),confirmText:\\\"I file Synology Office che non sono stati aperti e salvati tramite Synology Office 3.2 o versioni superiori saranno rimossi dopo l'eliminazione del database Synology Drive Server. Continuare?\\\",checkboxText:\\\"Dichiaro di avere compreso che quest'azione potrebbe causare la rimozione di tutti i miei file Synology Office.\\\",width:450,height:220});win.open();win.on('cancel',function(){checkbox.setValue(false)})};var panel=arguments[1];panel.items.items[panel.items.items.length-1].items.map[\\\"pkgwizard_remove_cstn_db\\\"].on('check',displayConfirmMessage);"
OFFICE_REPO_PATH=$(/bin/get_key_value /usr/syno/etc/packages/SynologyDrive/db-path.conf db-vol)/@SynoDrive/office

UNINSTALL_WITH_OFFICE=`/bin/cat<<EOF
{
    "step_title": "${PKG_STR_WIZARD_WZ_RM_TITLE}",
    "items": [{
		"desc": "${PKG_STR_WIZARD_WZ_REMOVEDB_DESC}"
	}, {
        "type": "multiselect",
        "subitems": [{
           "key": "pkgwizard_remove_cstn_db",
           "desc": "${PKG_STR_WIZARD_WZ_REMOVEDB}"
        }]
    }],
	"activeate": "{${PKG_STR_WIZARD_ACTIVATE_JS}}"
}
EOF`

UNINSTALL_WITHOUT_OFFICE=`/bin/cat<<EOF
{
    "step_title": "${PKG_STR_WIZARD_WZ_RM_TITLE}",
    "items": [{
		"desc": "${PKG_STR_WIZARD_WZ_REMOVEDB_DESC}"
	}, {
        "type": "multiselect",
        "subitems": [{
           "key": "pkgwizard_remove_cstn_db",
           "desc": "${PKG_STR_WIZARD_WZ_REMOVEDB}"
        }]
    }]
}
EOF`

IsOfficeInstalled()
{
	if [ ! -d ${OFFICE_REPO_PATH} ]; then
		return 0
	fi

	local office_repo_count=$(ls -l ${OFFICE_REPO_PATH} | wc -l)
	if [ "${office_repo_count}" = "1" ]; then
		return 0
	fi

	return 1
}

main()
{
	IsOfficeInstalled
	local office_installed=$?

	if [ "$office_installed" = "1" ]; then
		UninstallPage="${UNINSTALL_WITH_OFFICE}"
	else
		UninstallPage="${UNINSTALL_WITHOUT_OFFICE}"
	fi

/bin/cat > ${SYNOPKG_TEMP_LOGFILE} <<EOF
[${UninstallPage}]
EOF

	exit 0
}

main "$@"
