#!/bin/sh

#Conf dir/file definition
CSTN_PKG_ENABLE=/var/packages/SynologyDrive/enabled
CSTN_DB_PATH_DIR=/var/packages/SynologyDrive/etc
CSTN_DB_CONF="db-path.conf"

#Program path
CSTN_CLOUD_CONTROL="/var/packages/SynologyDrive/target/bin/cloud-control"
CSTN_FEASIBILITY_CHECK="/var/packages/SynologyDrive/target/bin/feasibility-check"

PackageEnableGet(){
    if [ -f "${CSTN_PKG_ENABLE}" ]; then
        echo "1";
		return 1;
    else
        echo "0";
		return "0";
    fi
}

start_service()
{
	${CSTN_CLOUD_CONTROL} service --start > /dev/null 2>&1
}

stop_service()
{
	${CSTN_CLOUD_CONTROL} service --stop > /dev/null 2>&1
}

set_db_vol()
{
	local conf_db_path="$1"
	local key="$2"
	local val="$3"
	logger -p 3 "calling /usr/syno/bin/synosetkeyvalue $conf_db_path $key $val"
	/usr/syno/bin/synosetkeyvalue "$conf_db_path" "$key" "$val"
}

